org.apache.http.impl.conn

## Class PoolingClientConnectionManager

- java.lang.Object
- - org.apache.http.impl.conn.PoolingClientConnectionManager

- All Implemented Interfaces:
    ClientConnectionManager, org.apache.http.pool.ConnPoolControl<HttpRoute>

  Deprecated.
  (4.3) use `PoolingHttpClientConnectionManager`.

      @Deprecated
      @Contract(threading=SAFE_CONDITIONAL)
      public class PoolingClientConnectionManager
      extends Object
      implements ClientConnectionManager, org.apache.http.pool.ConnPoolControl<HttpRoute>

  Manages a pool of `OperatedClientConnection` and is able to service connection requests from multiple execution threads. Connections are pooled on a per route basis. A request for a route which already the manager has persistent connections for available in the pool will be services by leasing a connection from the pool rather than creating a brand new connection.

  PoolingConnectionManager maintains a maximum limit of connection on a per route basis and in total. Per default this implementation will create no more than than 2 concurrent connections per given route and no more 20 connections in total. For many real-world applications these limits may prove too constraining, especially if they use HTTP as a transport protocol for their services. Connection limits, however, can be adjusted using HTTP parameters.

  Since:
    4.2

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PoolingClientConnectionManager()` Deprecated.
    `PoolingClientConnectionManager(SchemeRegistry schreg)` Deprecated.
    `PoolingClientConnectionManager(SchemeRegistry schreg, DnsResolver dnsResolver)` Deprecated.
    `PoolingClientConnectionManager(SchemeRegistry schemeRegistry, long timeToLive, TimeUnit timeUnit)` Deprecated.
    `PoolingClientConnectionManager(SchemeRegistry schemeRegistry, long timeToLive, TimeUnit timeUnit, DnsResolver dnsResolver)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeExpiredConnections()` Deprecated. Closes all expired connections in the pool.
    `void` | `closeIdleConnections(long idleTimeout, TimeUnit timeUnit)` Deprecated. Closes idle connections in the pool.
    `protected ClientConnectionOperator` | `createConnectionOperator(SchemeRegistry schreg)` Deprecated. Hook for creating the connection operator.
    `protected void` | `finalize()` Deprecated.
    `int` | `getDefaultMaxPerRoute()` Deprecated.
    `int` | `getMaxPerRoute(HttpRoute route)` Deprecated.
    `int` | `getMaxTotal()` Deprecated.
    `SchemeRegistry` | `getSchemeRegistry()` Deprecated. Obtains the scheme registry used by this manager.
    `org.apache.http.pool.PoolStats` | `getStats(HttpRoute route)` Deprecated.
    `org.apache.http.pool.PoolStats` | `getTotalStats()` Deprecated.
    `void` | `releaseConnection(ManagedClientConnection conn, long keepalive, TimeUnit timeUnit)` Deprecated. Releases a connection for use by others.
    `ClientConnectionRequest` | `requestConnection(HttpRoute route, Object state)` Deprecated. Returns a new `ClientConnectionRequest`, from which a `ManagedClientConnection` can be obtained or the request can be aborted.
    `void` | `setDefaultMaxPerRoute(int max)` Deprecated.
    `void` | `setMaxPerRoute(HttpRoute route, int max)` Deprecated.
    `void` | `setMaxTotal(int max)` Deprecated.
    `void` | `shutdown()` Deprecated. Shuts down this connection manager and releases allocated resources.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PoolingClientConnectionManager

          public PoolingClientConnectionManager(SchemeRegistry schreg)

      Deprecated.

    - #### PoolingClientConnectionManager

          public PoolingClientConnectionManager(SchemeRegistry schreg,
                                        DnsResolver dnsResolver)

      Deprecated.

    - #### PoolingClientConnectionManager

          public PoolingClientConnectionManager()

      Deprecated.

    - #### PoolingClientConnectionManager

          public PoolingClientConnectionManager(SchemeRegistry schemeRegistry,
                                        long timeToLive,
                                        TimeUnit timeUnit)

      Deprecated.

    - #### PoolingClientConnectionManager

          public PoolingClientConnectionManager(SchemeRegistry schemeRegistry,
                                        long timeToLive,
                                        TimeUnit timeUnit,
                                        DnsResolver dnsResolver)

      Deprecated.

  - ### Method Detail

    - #### finalize

          protected void finalize()
                           throws Throwable

      Deprecated.
      Overrides:
        `finalize` in class `Object`
      Throws:
        `Throwable`

    - #### createConnectionOperator

          protected ClientConnectionOperator createConnectionOperator(SchemeRegistry schreg)

      Deprecated.
      Hook for creating the connection operator. It is called by the constructor. Derived classes can override this method to change the instantiation of the operator. The default implementation here instantiates `DefaultClientConnectionOperator`.
      Parameters:
        `schreg` - the scheme registry.
      Returns:
        the connection operator to use

    - #### getSchemeRegistry

          public SchemeRegistry getSchemeRegistry()

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Obtains the scheme registry used by this manager.
      Specified by:
        `getSchemeRegistry` in interface `ClientConnectionManager`
      Returns:
        the scheme registry, never `null`

    - #### requestConnection

          public ClientConnectionRequest requestConnection(HttpRoute route,
                                                  Object state)

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Returns a new `ClientConnectionRequest`, from which a `ManagedClientConnection` can be obtained or the request can be aborted.
      Specified by:
        `requestConnection` in interface `ClientConnectionManager`

    - #### releaseConnection

          public void releaseConnection(ManagedClientConnection conn,
                               long keepalive,
                               TimeUnit timeUnit)

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Releases a connection for use by others. You may optionally specify how long the connection is valid to be reused. Values <= 0 are considered to be valid forever. If the connection is not marked as reusable, the connection will not be reused regardless of the valid duration. If the connection has been released before, the call will be ignored.
      Specified by:
        `releaseConnection` in interface `ClientConnectionManager`
      Parameters:
        `conn` - the connection to release
        `keepalive` - the duration of time this connection is valid for reuse
        `timeUnit` - the unit of time validDuration is measured in
      See Also:
        `ClientConnectionManager.closeExpiredConnections()`

    - #### shutdown

          public void shutdown()

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Shuts down this connection manager and releases allocated resources. This includes closing all connections, whether they are currently used or not.
      Specified by:
        `shutdown` in interface `ClientConnectionManager`

    - #### closeIdleConnections

          public void closeIdleConnections(long idleTimeout,
                                  TimeUnit timeUnit)

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Closes idle connections in the pool. Open connections in the pool that have not been used for the timespan given by the argument will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision All expired connections will also be closed.
      Specified by:
        `closeIdleConnections` in interface `ClientConnectionManager`
      Parameters:
        `idleTimeout` - the idle time of connections to be closed
        `timeUnit` - the unit for the `idletime`
      See Also:
        `ClientConnectionManager.closeExpiredConnections()`

    - #### closeExpiredConnections

          public void closeExpiredConnections()

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Closes all expired connections in the pool. Open connections in the pool that have not been used for the timespan defined when the connection was released will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision.
      Specified by:
        `closeExpiredConnections` in interface `ClientConnectionManager`

    - #### getMaxTotal

          public int getMaxTotal()

      Deprecated.
      Specified by:
        `getMaxTotal` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### setMaxTotal

          public void setMaxTotal(int max)

      Deprecated.
      Specified by:
        `setMaxTotal` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### getDefaultMaxPerRoute

          public int getDefaultMaxPerRoute()

      Deprecated.
      Specified by:
        `getDefaultMaxPerRoute` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### setDefaultMaxPerRoute

          public void setDefaultMaxPerRoute(int max)

      Deprecated.
      Specified by:
        `setDefaultMaxPerRoute` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### getMaxPerRoute

          public int getMaxPerRoute(HttpRoute route)

      Deprecated.
      Specified by:
        `getMaxPerRoute` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### setMaxPerRoute

          public void setMaxPerRoute(HttpRoute route,
                            int max)

      Deprecated.
      Specified by:
        `setMaxPerRoute` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### getTotalStats

          public org.apache.http.pool.PoolStats getTotalStats()

      Deprecated.
      Specified by:
        `getTotalStats` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

    - #### getStats

          public org.apache.http.pool.PoolStats getStats(HttpRoute route)

      Deprecated.
      Specified by:
        `getStats` in interface `org.apache.http.pool.ConnPoolControl<HttpRoute>`

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.